local loaded = false
maxShield,currentShield,lastShield,numShields,shieldRemaining = 0,0,0,0,0

ShieldWatchFrame = CreateFrame("Frame", nil, UIParent)
ShieldWatchFrame:SetBackdrop({
    bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
    insets = { left = 3, right = 3, top = 3, bottom = 3, },
})
ShieldWatchFrame:SetAlpha(0)
ShieldWatchFrame:EnableMouse(true)
ShieldWatchFrame:SetMovable(false)
ShieldWatchFrame:SetFrameStrata("BACKGROUND")
ShieldWatchFrame:Show()

ShieldWatchBar = CreateFrame("StatusBar", nil, ShieldWatchFrame)
ShieldWatchBar:SetPoint("TOPLEFT", 3, -3)
ShieldWatchBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
ShieldWatchBar:GetStatusBarTexture():SetHorizTile(false)
ShieldWatchBar:GetStatusBarTexture():SetVertTile(false)
ShieldWatchBar:SetMinMaxValues(0, 1)
ShieldWatchBar:SetValue(0)
ShieldWatchBar:SetWidth(200)
ShieldWatchBar:SetHeight(10)
ShieldWatchBar:SetFrameStrata("LOW")
ShieldWatchBar:SetStatusBarColor(0,1,0)
ShieldWatchBar:Show()

ShieldWatchTextFrame = CreateFrame("Frame", nil, UIParent)
ShieldWatchTextFrame:SetSize(206, 16)
ShieldWatchTextFrame:SetPoint("CENTER", ShieldWatchFrame, "CENTER")
ShieldWatchTextFrame:SetFrameStrata("MEDIUM")
ShieldWatchTextFrame:EnableMouse(false)
ShieldWatchTextFrame:Show()

ShieldWatchText = ShieldWatchTextFrame:CreateFontString(nil, "OVERLAY", "GameTooltipText")
ShieldWatchText:SetPoint("CENTER", ShieldWatchTextFrame, "CENTER")
ShieldWatchText:SetText("0")
ShieldWatchText:Hide()

ShieldWatchCount = ShieldWatchTextFrame:CreateFontString(nil, "OVERLAY", "GameTooltipText")
ShieldWatchCount:SetPoint("LEFT", ShieldWatchTextFrame, "LEFT")
ShieldWatchCount:SetText("0")
ShieldWatchCount:Hide()

ShieldWatchExpire = ShieldWatchTextFrame:CreateFontString(nil, "OVERLAY", "GameTooltipText")
ShieldWatchExpire:SetPoint("RIGHT", ShieldWatchTextFrame, "RIGHT")
ShieldWatchExpire:SetText("0")
ShieldWatchExpire:Hide()

local ShieldWatchEvents = CreateFrame("FRAME","ShieldWatchEvents",UIParent)
ShieldWatchEvents:SetFrameStrata("BACKGROUND")
ShieldWatchEvents:SetWidth(2)
ShieldWatchEvents:SetHeight(2)
ShieldWatchEvents:SetPoint("BOTTOM", WorldFrame, "BOTTOM", 0, -10)
ShieldWatchEvents:Show()

ShieldWatchEvents:RegisterEvent("ADDON_LOADED")

SLASH_SHIELDWATCH1 = "/shieldwatch"

function handler(str)
	local switch, msg = str:match("([^ ]+) (.*)")
	if switch == "lock" then
		ShieldWatchFrame:SetMovable(false)
		ShieldWatchFrame:StopMovingOrSizing()
	elseif switch == "unlock" then
		ShieldWatchFrame:SetMovable(true)
	elseif (switch == "setwidth") then
		local numStart,numEnd = msg:find("%d+")
		local numText = msg:sub(numStart,numEnd)
		local num = tonumber(numText)
		if (num >= 50 and num <= 250) then
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
			ShieldWatchTextFrame:SetWidth(num-6)
		end
	elseif (switch == "setheight") then
		local numStart,numEnd = msg:find("%d+")
		local numText = msg:sub(numStart,numEnd)
		local num = tonumber(numText)
		if (num >= 16 and num <= 40) then
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetHeight(num)
			ShieldWatchBar:SetHeight(num-6)
			ShieldWatchTextFrame:SetHeight(num-6)
		end
	else
		ChatFrame1:AddMessage("ShieldWatch commands:")
		ChatFrame1:AddMessage("/shieldwatch [lock/unlock] - set bar's moving state")
		ChatFrame1:AddMessage("/shieldwatch setwidth (50-250) - set bar's width")
		ChatFrame1:AddMessage("/shieldwatch setheight (16-80) - set bar's height")
	end
end

SlashCmdList["SHIELDWATCH"] = handler

function scanBuffs()
	currentShield = 0
	numShields = 0
	shieldRemaining = 1000
	for i=1,40 do
		ShieldWatchTooltip:ClearLines()
		ShieldWatchTooltip:SetUnitBuff("player", i)
		local text = getglobal(ShieldWatchTooltip:GetName().."TextLeft2"):GetText()
		if text==nil then
			break
		end
		if text:find("[aA]bsorb") then
			if (text:find("%d")) then
				local _,_,_,_,_,_,expiry=UnitBuff("player", i)
				expiry = floor(expiry - GetTime())
				if (expiry < shieldRemaining) then
					shieldRemaining = expiry
				end
				local num = text:sub(text:find("%d+"))
				currentShield = currentShield + num
				numShields=numShields+1
			end
		end
	end
	if (currentShield > lastShield) then
		maxShield = currentShield
	end
	lastShield = currentShield
end

function ShieldWatchEvents:OnEvent(event, arg1)---------------------------------------------------------------------Loading
	if (event == "ADDON_LOADED") then
		if not (SWpoint and SWrelPoint and SWxoff and SWyoff) then
			SWpoint = "CENTER"
			SWrelPoint = "CENTER"
			SWxoff = 0
			SWyoff = 0
		end
		if (SWxsize == nil or SWysize == nil) then
			SWxsize = 206
			SWysize = 16
		end
	end
end

ShieldWatchEvents:HookScript("OnEvent", ShieldWatchEvents.OnEvent)

ShieldWatchFrame:HookScript("OnUpdate", function()
	if (ShieldWatch_Elapsed == nil) then
		ShieldWatch_Elapsed = GetTime()
	end
	if (not loaded) then
		if (GetTime() >= ShieldWatch_Elapsed + 1) then--------------------------------------------------Delayed load
			ShieldWatchFrame:SetPoint(SWpoint, WorldFrame, SWrelPoint, SWxoff, SWyoff)
			ShieldWatchFrame:SetSize(SWxsize, SWysize)
			ShieldWatchBar:SetSize(SWxsize-6, SWysize-6)
			ShieldWatchTextFrame:SetSize(SWxsize-6, SWysize-6)
			loaded = true
			ShieldWatch_Elapsed = GetTime()
		end
	elseif (GetTime() >= ShieldWatch_Elapsed + 0.25) then
		scanBuffs()
		if (currentShield>0) then
			ShieldWatchFrame:EnableMouse(true)
			ShieldWatchBar:SetValue(currentShield)
			ShieldWatchText:SetText(currentShield)
			ShieldWatchCount:SetText(numShields)
			ShieldWatchExpire:SetText(shieldRemaining)
			ShieldWatchBar:SetMinMaxValues(0,maxShield)
			if (ShieldWatchFrame:GetAlpha() == 0) then
				ShieldWatchFrame:SetAlpha(1)
				ShieldWatchText:Show()
				ShieldWatchCount:Show()
				ShieldWatchExpire:Show()
			end
		elseif (ShieldWatchFrame:GetAlpha() > 0) then
			ShieldWatchFrame:StopMovingOrSizing()
			ShieldWatchFrame:EnableMouse(false)
			ShieldWatchFrame:SetAlpha(0)
			ShieldWatchText:Hide()
			ShieldWatchCount:Hide()
			ShieldWatchExpire:Hide()
		end
		ShieldWatch_Elapsed = GetTime()
	end
end)

ShieldWatchFrame:HookScript("OnMouseUp", function(self, button)
	ShieldWatchFrame:StopMovingOrSizing()
	if (button == "RightButton" and ShieldWatchFrame:GetAlpha() > 0) then
		ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
	else
		SWpoint,_,SWrelPoint,SWxoff,SWyoff=ShieldWatchFrame:GetPoint()
		SWxsize,SWysize=ShieldWatchFrame:GetSize()
	end
end)

ShieldWatchFrame:HookScript("OnMouseDown", function(self, button)
	if (ShieldWatchFrame:IsMovable() and button == "LeftButton") then
		ShieldWatchFrame:StartMoving()
	end
end)

function ShieldWatch_DropDownOnLoad(self)
	UIDropDownMenu_Initialize(self, ShieldWatch_InitializeDropDown, "MENU", 1)
end

function ShieldWatch_InitializeDropDown(self, level)
	if level == 1 then
		local info = {}

		info.text = "ShieldWatch"
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, level)

		info = {}
		if (ShieldWatchFrame:IsMovable()) then
			info.text = "Lock"
		else
			info.text = "Unlock"
		end
		function info.func()
			ShieldWatchFrame:SetMovable(not ShieldWatchFrame:IsMovable())
		end
		UIDropDownMenu_AddButton(info, level)
	
		info = {}
		info.text = "Width"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, level)
	
		info = {}
		info.text = "Height"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, level)

		info = {}
		info.text = "Cancel"
		UIDropDownMenu_AddButton(info, level)
	elseif (level == 2 and UIDROPDOWNMENU_MENU_VALUE == "Width" )then
		local info = {}

		info.text = "50"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 50
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "100"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 100
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "150"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 150
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "200"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 200
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "250"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 250
			ChatFrame1:AddMessage("Bar width set to "..num)
			ShieldWatchFrame:SetWidth(num)
			ShieldWatchBar:SetWidth(num-6)
		end
		UIDropDownMenu_AddButton(info, level)
	elseif (level == 2 and UIDROPDOWNMENU_MENU_VALUE == "Height" )then
		local info = {}

		info.text = "16"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 16
			ChatFrame1:AddMessage("Bar height set to "..num)
			ShieldWatchFrame:SetHeight(num)
			ShieldWatchBar:SetHeight(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "28"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 28
			ChatFrame1:AddMessage("Bar height set to "..num)
			ShieldWatchFrame:SetHeight(num)
			ShieldWatchBar:SetHeight(num-6)
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = "40"
		function info.func()
			ToggleDropDownMenu(1, nil, ShieldWatch_DropDown, "cursor", 0, 0)
			local num = 40
			ChatFrame1:AddMessage("Bar height set to "..num)
			ShieldWatchFrame:SetHeight(num)
			ShieldWatchBar:SetHeight(num-6)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end